unit game;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ddsd, Ddidex, DGCarad9, s_mathpack, SXLib9,d3d9, AppEvnts,
  octettree, defs, util;

const
  MAX_MOVERS = 4096;  //úv̓o
  MAX_LIGHTS = 8;

type

//̂̑
//@@@@@  sg@  @        e @       G@@         Ge
TMoverAttr = (maThru,maPlayer1,maPlayer1Bullet, maPlayer2, maPlayer2Bullet);

TMover = class;

//úṽXg
TMoverList = class(TList)
  private
    FTick:Integer;
    AgeT:Single;
    function GetMover(idx: Integer): TMover;
  public
    constructor Create;
    destructor Destroy; override;
    property Mover[idx:Integer]:TMover read GetMover; default;
    function AddMover:TMover;
    procedure Delete(idx:Integer);
    procedure Move(dt:Single);
end;

//úvNX
TMover = class
  private
    FDead:Boolean;    //񂾁H@tO
  protected
    Tick:Integer;     //Move\bȟĂ΂ꂽ
    AgeT:Single;      //N
    BirthT:Single;    //a

    FTouchSphere:Array[0..7] of TSphere3D; //蔻p
    nTouchSphere:Integer;                  //Lȓ苅̐
    Owner:TMoverList; //ǗMoverList
  public
    Attr:TMoverAttr;
    constructor Create(AOwner:TMoverList; birthTime:Single);
    procedure Die; virtual;
    procedure Move(dt:Single); virtual;
    function CheckTouch(Target:TMover):Boolean; virtual; //蔻
    procedure OnCrush(target:TMover); virtual;
    procedure OnDamaged(target:TMover; dmg:Integer); virtual;
    procedure CatchMessage(from:TMover; info1,info2:Integer; xInfo:Pointer); virtual;
end;

//Q[J[l
TGame =class
  private
    Movers:TMoverList;
    Camera:TSXFrame;
    Root:TSXFrame;
    Map:TOctree;
    Lights:TSXLightGroup;
    Players:Array[0..1] of TMover;
  public
    constructor Create;
    destructor Destroy; override;
    procedure Move(dt:Single);
    procedure GameStart;
    procedure GameOver;
end;


implementation

uses
  commonObj, fighter, Reimu;

{ TGame }

constructor TGame.Create;
begin
end;

destructor TGame.Destroy;
begin
  if GameState = gsGame then
    GameOver;
  inherited;
end;

//Q[I
procedure TGame.GameOver;
begin
  Movers.Free;
  CommonRes.Free;

  Lights.Free;
  Map.Free;
  Root.Free;
  TheWorld:=Nil;
  TheCamera:=Nil;
  TheMap:=Nil;
end;

//Q[Jn
procedure TGame.GameStart;
var
  i:Integer;
begin
  //
  Movers:=TMoverList.Create;

  //t[̐ݒ
  Root:=TSXframe.Create(Nil);
  TheWorld:=Root;
  Camera:=TSXFrame.Create(Root);
  Scene.CameraFrame:=Camera;

  Camera.SetTranslation(Root, Vector(0,1.5,0));
  TheCamera:=Camera;

  //ʃf[^ǂݍ
  CommonRes:=TResourceContainer.Create;

  //̐ݒ
  Lights:=TSXLightGroup.Create(DG,MAX_LIGHTS);
  Lights[0].Enabled:=True;
  Lights[0].SetupDirectional(NowNormalize(Vector(1,-1,-1)));
  Lights[0].SetupColors(1.0,1.0,1.0, 1.0,1.0,1.0, 0.5,0.5,0.5);

  //}bv̍\z
  Map:=TOctree.Create(DG);
  Map.BuildFromMQO(PATH+'map\map1.mqo',10.0, 0);
  Map.Frame.Parent:=Root;
  //Map.Frame.SetMaterialRcv(MakeMaterial(1,1,1, 1,1,1, 1,1,1, 1,1,1, 30));
  Map.Frame.SetSpecularRcv(True);
  TheMap:=Map;

  {bŃR[h}
  //얲2Au
  players[0]:=TReimu.Create(Movers, Now_T, ctPlayer1);
  TReimu(players[0]).SetPosition(Vector(0,1,-10));
  TReimu(players[0]).Frame.SetOrientation(Root, Vector(0,0,1), Vector(0,1,0));

  players[1]:=TReimu.Create(Movers, Now_T, ctPlayer2);
  TReimu(players[1]).SetPosition(Vector(0,1,10));
  TReimu(players[1]).Frame.SetOrientation(Root, Vector(0,0,-1), Vector(0,1,0));

  TReimu(players[0]).opponent:=TFighter(players[1]);
  TReimu(players[1]).opponent:=TFighter(players[0]);
  for i:=0 to 1 do
    Movers.Add(players[i]);
end;

procedure TGame.Move(dt: Single);
begin
  //͓ǂ
  PollController(0);
  PollController(1);

  Movers.Move(dt);

  //J͎l(player1)̃Jg
  TheCamera:=TFighter(players[0]).CameraFrame;
  Scene.CameraFrame:=TheCamera;
end;

{ TMover }

constructor TMover.Create(AOwner:TMoverList; birthTime:Single);
begin
  Owner:=AOwner;
  BirthT:=birthTime;
  AgeT:=0;
  Tick:=0;
  Attr:=maThru;
end;

procedure TMover.Die;
begin
  FDead:=True;
end;

procedure TMover.Move(dt: Single);
begin
  AgeT:=AgeT + dt;
  Inc(Tick);
end;

function TMover.CheckTouch(Target: TMover): Boolean;
var
  i,j:Integer;
begin
  result:=False;
  for i:=0 to nTouchSphere-1 do begin
    for j:=i to Target.nTouchSphere-1 do begin
      if NowDistance(FTouchSphere[i].Center,Target.FTouchSphere[j].Center) <=
        FTouchSphere[i].Radius + Target.FTouchSphere[j].Radius then
          result:=True;
    end;
  end;
end;

procedure TMover.CatchMessage(from: TMover; info1, info2: Integer;
  xInfo: Pointer);
begin

end;

procedure TMover.OnCrush(target: TMover);
begin

end;

procedure TMover.OnDamaged(target: TMover; dmg: Integer);
begin

end;

{ TMoverList }

function TMoverList.AddMover: TMover;
var
  newMover:TMover;
begin
  newMover:=TMover.Create(Self, Now_T);
  Add(newMover);
  result:=newMover;
end;


constructor TMoverList.Create;
begin
  inherited Create;
end;

procedure TMoverList.Delete(idx: Integer);
begin
  if Mover[idx] <> Nil then
    Mover[idx].Free;
  Items[idx]:=Nil;
  inherited Delete(idx);
end;

destructor TMoverList.Destroy;
begin
  while Count > 0 do
    Delete(Count-1);
  inherited;
end;

function TMoverList.GetMover(idx: Integer): TMover;
begin
  result:=TMover(Items[idx]);
end;

procedure TMoverList.Move(dt: Single);
var
  i,j:Integer;
  mi,mj:TMover;
  nHB,nEB,nHero,nEnemy:Integer; //eJeSɑIuWFNg̐
  MatHB,MatEB,MatHero,MatEnemy:Array[0..MAX_MOVERS-1] of TMover;  //Ƃ肠ꂾႢł
begin
  AgeT:=AgeT + dt;
  Inc(FTick);


  //( ̉
  i:=0;
  while i<Count do begin
    if Mover[i].FDead then begin
      Delete(i);
      Continue;
    end;
    Inc(i);
  end;

  //S
  for i:=0 to Count-1 do begin
    if not Mover[i].FDead then
      Mover[i].Move(dt);
  end;

  //蔻

  //eIuWFNgU蕪
  nHB:=0; nEB:=0; nHero:=0; nEnemy:=0;
  For i:=0 to Count-1 do begin
    Case Mover[i].Attr of
      maPlayer1Bullet: begin MatHB[nHB]:=Mover[i];  Inc(nHB); end;
      maPlayer2Bullet: begin MatEB[nEB]:=Mover[i];  Inc(nEB); end;
      maPlayer1: begin MatHero[nHero]:=Mover[i];  Inc(nHero); end;
      maPlayer2: begin MatEnemy[nEnemy]:=Mover[i];  Inc(nEnemy); end;
      //maEraser: begin MatEraser[nEraser]:=Mover[i];  Inc(nEraser); end;
    end;
  end;


  //܂łōsɁA蔻s
  //NMaxCrush:=(nHB*nEnemy + nEB*nHero + nEnemy*nHero + nEB*nEraser) Shr 1;
  //NCrush:=0;

  //q[[eƓG
  For i:=0 to nHB-1 do begin
    mi:=MatHB[i];
    For j:=0 to nEnemy-1 do begin
      mj:=MatEnemy[j];
      if mj.FDead then
        Continue;

      if mi.CheckTouch(mj) then begin
         //Inc(nCrush);
         mi.OnCrush(mj);
         mj.OnCrush(mi);
      end;

      if mi.FDead then
        Break;
    end;
  end;

  //Geƃq[[
  For i:=0 to nEB-1 do begin
    mi:=MatEB[i];
    For j:=0 to nHero-1 do begin
      mj:=MatHero[j];
      if mj.FDead then
        Continue;

      if mi.CheckTouch(mj) then begin
         //Inc(nCrush);
         mi.OnCrush(mj);
         mj.OnCrush(mi);
      end;

      if mi.FDead then
        Break;
    end;
  end;

  //q[[ƓG
  For i:=0 to nHero-1 do begin
    mi:=MatHero[i];
    For j:=0 to nEnemy-1 do begin
      mj:=MatEnemy[j];
      if mj.FDead then
        Continue;

      if mi.CheckTouch(mj) then begin
         //Inc(nCrush);
         mi.OnCrush(mj);
         mj.OnCrush(mi);
      end;

      if mi.FDead then
        Break;
    end;
  end;

end;

end.
